//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                            Bogie-maHiLo-v1.0.mq4 |
//|                              Copyright  2007, Bogie Enterprises |
//|                                         
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Bogie Enterprises"

//       ====== Inputs ======

extern bool    UseEmail          = true;
extern bool    UseMM             = true;     // 1 = true & 0 = false
extern double  Risk              = 50;       // percent of account equity to risk per trade
extern double  Lots              = 0.1;
extern int     Gap               = 2;
extern int     TakeProfit        = 90;          

extern double  TrailingStop      = 0;       // 0 = no trailing stop


extern int     MA_1              = 20;        // First iMA period
extern int     MA_2              = 32;        // Second iMA period

extern int     MA_Method1        = 3;        // 0=SMA, 1=EMA, 2=SMMA, 3=LWMA
extern int     MA_Method2        = 3;

extern int     MA_AppliedPrice1  = 2;        // 0=close, 1-open, 2=high, 3=low, 4=median, 5=typical, 6=weighted close
extern int     MA_AppliedPrice2  = 3;

extern double  MinMarginLevel    = 250;      // Below this Minimum Margin Level percent % trading stops

int            MagicNumber       = 7447;
int            BarTime           = 0;
double         sl                = 0;


//       ====== Program Start ======

int start()
  {
   
//         ====== Money Management of Lot Size routine ======  
  
   
    if(UseMM) Lots=AccountEquity()* Risk/100/1000;

    if( Lots>0.1)Lots=NormalizeDouble(Lots,1); else Lots=NormalizeDouble(Lots,2);
    

//          ====== Trade Trigger Calculation Routine =======

   int Buy1=0,Sell1=0;
   Buy1=0;
   Sell1=0;
   
   double MA1 =NormalizeDouble(iMA(NULL,0,MA_1,0,MA_Method1,MA_AppliedPrice1,0),Digits);
   double MA2 =NormalizeDouble(iMA(NULL,0,MA_2,0,MA_Method2,MA_AppliedPrice2,0),Digits);
   double MA3 =NormalizeDouble(iMA(NULL,0,MA_1,0,MA_Method1,MA_AppliedPrice1,1),Digits);
   
   
   if(  MA1-Gap*Point > MA3 && Low[1] > MA1)  
      {  
         Buy1=1;
      }
             
   if( MA1+Gap*Point < MA3 && High[1] < MA2) 
      {
         Sell1=1; 
      }
      
      
      
   if(Buy1==1 ) Comment("Open Orders = ",MyOrdersTotal(),"  === Buy ===");
            
   if(Sell1==1 ) Comment("Open Orders = ",MyOrdersTotal(),"  === Sell ===");
               
   if( Buy1!=1 && Sell1!=1) Comment("Open Orders = ",MyOrdersTotal());
   
   
   bool CLOSEBuy=false;
   bool CLOSESell=false;
   
   if (TimeCurrent()-BarTime>(Period()*60))
   {
   if( Low[0]<MA2 ) CLOSEBuy=true;
   if( High[0]>MA1 ) CLOSESell=true;
   }
    
   
   
//          ====== Order Open Routine ======   

   int cnt, ticket, total, OrderIsOpen=0;
   total  = OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if((OrderSymbol()==Symbol())&& (OrderMagicNumber()==MagicNumber))
         {
         OrderIsOpen=1;
         break;
         }
      else
         continue; 
      }  
    if(MyOrdersTotal()==0 && AccountEquity()/(AccountMargin()+0.0001)>(MinMarginLevel/100)) 
      {
      if(Buy1==1 ) 
         {
         BarTime=TimeCurrent();
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,MA2,Ask+TakeProfit*Point,"BUYSignal",MagicNumber,0,GreenYellow);
         if(UseEmail) SendMail("Signal Alert - Bogie-maHiLo-v1.0","[" + Symbol() + "]  " + DoubleToStr(Ask,Digits) + "  Open Sell"
         +"  sl = "+DoubleToStr(MA2,Digits)+"  tp = "+DoubleToStr(Ask+TakeProfit*Point,Digits));
         if(ticket>0)
            {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
            }
            else Print("Error opening BUY order : ",GetLastError()); 
            return(0);
         }

      if(Sell1==1 )
         {
         BarTime=TimeCurrent();
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,MA1,Bid-TakeProfit*Point,"SELLSignal",MagicNumber,0,Red);
         if(UseEmail) SendMail("Signal Alert - Bogie-maHiLo-v1.0","[" + Symbol() + "]  " + DoubleToStr(Bid,Digits) + "  Open Sell"
         +"  sl = "+DoubleToStr(MA1,Digits)+"  tp = "+DoubleToStr(Bid-TakeProfit*Point,Digits));
         if(ticket>0)
            {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
            }
            else Print("Error opening SELL order : ",GetLastError()); 
            return(0);
         }
      }
     

//          ====== Trailing Stop  Routine ======
  
   total = OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if((OrderType() <= OP_SELL) && (OrderSymbol() == Symbol()) )
         {
         if(OrderType() == OP_BUY)
            {
            if(TrailingStop>0 && Bid-OrderOpenPrice() > Point*TrailingStop)
               {
               if(OrderStopLoss() < Bid-Point*TrailingStop)
                  { 
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*Point,OrderTakeProfit(),0,GreenYellow);
                  }
               }
               if(CLOSEBuy == true )
                  {
                  OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); 
                  }
            }

            if(OrderType() == OP_SELL)
               {
               if(TrailingStop>0 && OrderOpenPrice()-Ask>Point*TrailingStop)
                  {
                  if(OrderStopLoss()>Ask+Point*TrailingStop)
                     {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*Point,OrderTakeProfit(),0,Red);              
                     }
                  }      

                  if(CLOSESell == true )
                  {
                  OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); 
                  }
                }
             }
          }

   return(0);
  }
   
   
   
//          ====== Sub-Routines ======
   
   int MyOrdersTotal() { // included by Renato
   int Mytotal=0; 
   for (int i=0; i<OrdersTotal(); i++) { 
     if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
       if((OrderSymbol()==Symbol())) 
          Mytotal++; 
   }  
   return(Mytotal); 
} 
  
//+---------------------- The End -----------------------------